<?php
/* --------------------------------------------------------------
   GXCoreLoaderSettings.inc.php 2015-01-30 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2015 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

MainFactory::load_class('GXCoreLoaderSettingsInterface');

/**
 * Class GXCoreLoaderSettings
 *
 * Wraps needed settings from the environment.
 *
 * @category System
 * @package  GXCoreLoader
 */
class GXCoreLoaderSettings implements GXCoreLoaderSettingsInterface
{
	/**
	 * @var string
	 */
	protected $databaseUser;
	/**
	 * @var string
	 */
	protected $databasePassword;
	/**
	 * @var string
	 */
	protected $databaseServer;
	/**
	 * @var string
	 */
	protected $databaseName;

	/**
	 * @var string
	 */
	protected $databaseSocket;


	/**
	 * Uses the credentials in configure.php for setting the member variables
	 */
	public function __construct()
	{
		$this->databaseUser     = DB_SERVER_USERNAME;
		$this->databasePassword = DB_SERVER_PASSWORD;
		$this->databaseServer   = DB_SERVER;
		$this->databaseName     = DB_DATABASE;

		if(strpos(DB_SERVER, ':/')) // mysql socket detected
		{
			$exploded             = explode(':', DB_SERVER);
			$this->databaseServer = array_shift($exploded);
			$this->databaseSocket = array_shift($exploded);
		}
	}


	/**
	 * @return string
	 */
	public function getDatabaseName()
	{
		return $this->databaseName;
	}


	/**
	 * @return string
	 */
	public function getDatabasePassword()
	{
		return urlencode($this->databasePassword); // needs to encode slashes and other characters
	}


	/**
	 * @return string
	 */
	public function getDatabaseServer()
	{
		return $this->databaseServer;
	}


	/**
	 * @return string
	 */
	public function getDatabaseUser()
	{
		return $this->databaseUser;
	}


	public function getDatabaseSocket()
	{
		return $this->databaseSocket;
	}
}