<?php
require 'includes/application_top.php';
defined('TABLE_INFOBOX_MESSAGES') or define('TABLE_INFOBOX_MESSAGES', 'infobox_messages');
defined('TABLE_INFOBOX_MESSAGES_DESCRIPTION') or define('TABLE_INFOBOX_MESSAGES_DESCRIPTION', 'infobox_messages_description');

ob_start();

if(!(isset($_SESSION['customers_status']['customers_status_id']) && $_SESSION['customers_status']['customers_status_id'] == 0)) {
	die('unauthorized');
}

$sql = array();
$add_cols = array();
$dirs = array();
$fileperms = array();
$orders_status = array();
$lang_files_content = array();
$mail_templates = array();

/* ================================================================================================= */

$min_php = '5.3';

$admin_access = array('admin');

$sql[] = "CREATE TABLE IF NOT EXISTS `configuration_storage` (
  `key` varchar(255) NOT NULL,
  `value` varchar(255) DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`key`)
) ENGINE=MyISAM";

$sql[] =
	'CREATE TABLE IF NOT EXISTS `orders_paypal_payments` (
	  `orders_id` int(11) NOT NULL,
	  `payment_id` varchar(48) NOT NULL,
	  `mode` varchar(8) NOT NULL,
	  PRIMARY KEY (`orders_id`,`payment_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8';

$sql[] =
	'CREATE TABLE IF NOT EXISTS `paypal_paylink` (
	  `orders_id` int(10) unsigned NOT NULL,
	  `paycode` varchar(32) NOT NULL,
	  `amount` decimal(15,4) DEFAULT NULL,
	  PRIMARY KEY (`orders_id`),
	  KEY `paycode` (`paycode`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;';


$sql[] =
	'CREATE TABLE IF NOT EXISTS `orders_payment_instruction` (
	 `orders_payment_instruction_id` int(11) NOT NULL AUTO_INCREMENT,
	 `orders_id` int(11) NOT NULL,
	 `reference` varchar(255) NOT NULL,
	 `bank_name` varchar(255) NOT NULL,
	 `account_holder` varchar(255) NOT NULL,
	 `iban` varchar(34) NOT NULL,
	 `bic` varchar(11) NOT NULL,
	 `value` decimal(10,4) NOT NULL,
	 `currency` varchar(3) NOT NULL,
	 `due_date` date NOT NULL,
	 PRIMARY KEY (`orders_payment_instruction_id`),
	 KEY `orders_id` (`orders_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8';

/* ================================================================================================= */

class MailTemplateInstaller
{
	protected $_mail_template_file;
	protected $_admin_labels;

	public function __construct($p_mail_template_file, $p_mail_template_folder = '')
	{
		$this->_mail_template_file = $p_mail_template_file;
		$this->_mail_template_folder = $p_mail_template_folder;
		$this->_admin_labels = array();
	}

	public function set_admin_label($p_language, $p_label)
	{
		$this->_admin_labels[$p_language] = $p_label;
	}

	public function install()
	{
		$t_language = MainFactory::create_object('language');
		foreach($t_language->catalog_languages as $clang)
		{
			$t_template_file_html = DIR_WS_LANGUAGES.'/'.$clang['directory'].'/mail_templates/'.$this->_mail_template_folder.$this->_mail_template_file.'.html';
			$t_template_file_text = DIR_WS_LANGUAGES.'/'.$clang['directory'].'/mail_templates/'.$this->_mail_template_folder.$this->_mail_template_file.'.txt';
			if(file_exists($t_template_file_html) && file_exists($t_template_file_text))
			{
				$t_template_content_html = file_get_contents($t_template_file_html);
				$t_template_content_text = file_get_contents($t_template_file_text);
				$t_gm_emails_id = $this->_find_gm_emails_id($clang['id'], $this->_mail_template_file, $this->_mail_template_folder);
				if($t_gm_emails_id === false)
				{
					echo 'installing new template '.$clang['code'].'<br>';
					$t_new_gm_email_id = $this->_find_next_gm_email_id();
					$t_sql_data = array(
						'gm_email_id' => $t_new_gm_email_id,
						'languages_id' => $clang['id'],
						'folder' => $this->_mail_template_folder,
						'filename' => $this->_mail_template_file,
						'backup_original_html' => $t_template_content_html,
						'backup_original_txt' => $t_template_content_text,
						'backup_user_html' => $t_template_content_html,
						'backup_user_txt' => $t_template_content_text,
						'html' => $t_template_content_html,
						'txt' => $t_template_content_text,
					);
					xtc_db_perform('gm_emails', $t_sql_data, 'insert');
					if(isset($this->_admin_labels[$clang['code']]))
					{
						$t_section_id = $this->_find_section_id($clang['id'], 'lang/'.$clang['directory'].'/admin/gm_emails.php');
						echo "section id is $t_section_id<br>";
						$t_label_sql_data = array(
							'language_section_id' => $t_section_id,
							'phrase_name' => 'GM_EMAILS_TEMPLATE_'.$t_new_gm_email_id,
							'phrase_value' => $this->_admin_labels[$clang['code']],
						);
						echo htmlspecialchars(print_r($t_label_sql_data, true)).'<br>';
						xtc_db_perform('language_section_phrases', $t_label_sql_data, 'insert');
					}
				}
				else
				{
					echo 'updating existing template<br>';
					$t_sql_data = array(
						'backup_original_html' => $t_template_content_html,
						'backup_original_txt' => $t_template_content_text,
					);
					xtc_db_perform('gm_emails', $t_sql_data, 'update', 'gm_emails_id = '.$t_gm_emails_id);

				}
			}
			else
			{
				throw new Exception('Template file missing: '.$this->_mail_template_folder.$this->_mail_template_file);
			}
		}
	}

	protected function _find_next_gm_email_id()
	{
		$t_query = 'SELECT MAX(`gm_email_id`) AS max_mail_id FROM `gm_emails`';
		$t_result = xtc_db_query($t_query);
		$t_max_id = false;
		while($t_row = xtc_db_fetch_array($t_result))
		{
			$t_max_id = $t_row['max_mail_id'];
		}
		if($t_max_id === false)
		{
			throw new Exception('ERROR finding new mail id!');
		}
		$t_next_mail_id = $t_max_id + 1;
		return $t_next_mail_id;
	}

	protected function _find_gm_emails_id($p_languages_id, $p_mail_template_file, $p_mail_template_folder = '')
	{
		$t_query =
			'SELECT
				`gm_emails_id`
			FROM
				`gm_emails`
			WHERE
				`languages_id` = \':languages_id\' AND
				`filename` = \':filename\' AND
				`folder` = \':folder\'';
		$t_query = strtr($t_query, array(
			':languages_id' => (int)$p_languages_id,
			':filename' => xtc_db_input($p_mail_template_file),
			':folder' => xtc_db_input($p_mail_template_folder),
		));
		$t_result = xtc_db_query($t_query);
		$t_gm_emails_id = false;
		while($t_row = xtc_db_fetch_array($t_result))
		{
			$t_gm_emails_id = $t_row['gm_emails_id'];
		}
		return $t_gm_emails_id;
	}

	protected function _find_section_id($p_language_id, $p_section_name)
	{
		$t_sql =
			'SELECT
				`language_section_id`
			FROM
				`language_sections`
			WHERE
				`language_id` = \':language_id\' AND
				`section_name`  = \':section_name\'';
		$t_sql = strtr($t_sql, array(
			':language_id' => (int)$p_language_id,
			':section_name' => xtc_db_input($p_section_name),
		));
		$t_result = xtc_db_query($t_sql);
		$t_language_section_id = false;
		while($t_row = xtc_db_fetch_array($t_result))
		{
			$t_language_section_id = $t_row['language_section_id'];
		}
		return $t_language_section_id;
	}
}

/* ================================================================================================= */


function addColumn($coldef) {
	if(!columnExists($coldef['table'], $coldef['column'])) {
		$query = "ALTER TABLE `:table` ADD :coldef";
		$query = strtr($query, array(':table' => $coldef['table'], ':coldef' => $coldef['coldef']));
		xtc_db_query($query);
	}
}

function addLanguageContant($langdef) {
	$check_query = "SELECT * FROM `gm_lang_files_content` WHERE `constant_name` LIKE '%".$langdef['constant_name']."%'";
	$check_result = xtc_db_query($check_query);
	$entry_missing = xtc_db_num_rows($check_result) == 0;
	if($entry_missing == true) {
		$insert_query = "INSERT INTO `gm_lang_files_content` (`lang_files_id`, `constant_name`, `constant_value`) ".
			"VALUES (:lang_files_id, ':constant_name', ':constant_value')";
		$insert_query = strtr($insert_query, array(
			':lang_files_id' => (int)$langdef['lang_files_id'],
			':constant_name' => $langdef['constant_name'],
			':constant_value' => xtc_db_input($langdef['constant_value'])));
		xtc_db_query($insert_query);
	}
}

function addOrdersStatus($orders_status_id, $statusname, $language_id) {
	if(($insert_id = ordersStatusExists($statusname, $language_id)) === false) {
		xtc_db_query("INSERT INTO orders_status (orders_status_id, language_id, orders_status_name) VALUES (".(int)$orders_status_id.", ".(int)$language_id.", '".$statusname."')");
		$insert_id = xtc_db_insert_id();
	}
	return $insert_id;
}

function ordersStatusExists($statusname, $language_id) {
	$query = "SELECT orders_status_id FROM orders_status WHERE language_id = ".(int)$language_id." AND orders_status_name LIKE '%".$statusname."%'";
	$result = xtc_db_query($query);
	$orders_status_id = false;
	while($row = xtc_db_fetch_array($result)) {
		$orders_status_id = $row['orders_status_id'];
	}
	return $orders_status_id;
}

function findNextOrdersStatusId() {
	$query = "SELECT ((FLOOR(MAX(orders_status_id) / 10) + 1) * 10) AS next_id FROM `orders_status`";
	$result = xtc_db_query($query);
	$row = xtc_db_fetch_array($result);
	return $row['next_id'];
}

function columnExists($table, $column) {
	$col_exists_query = "show columns from `:table` like ':colname'";
	$col_exists_query = strtr($col_exists_query, array(':table' => $table, ':colname' => $column));
	$ce_result = xtc_db_query($col_exists_query);
	$column_exists = xtc_db_num_rows($ce_result) > 0;
	return $column_exists;
}

function addAdminAccess($entity, $allow_all = true) {
	$col_exists_query = "show columns from admin_access like ':colname'";
	$col_exists_query = strtr($col_exists_query, array(':colname' => $entity));
	$ce_result = xtc_db_query($col_exists_query);
	if(xtc_db_num_rows($ce_result) > 0) {
		// columns already exists, don't do anything
		return false;
	}
	$add_col_query = "ALTER TABLE `admin_access` ADD `:colname` INT( 1 ) NOT NULL DEFAULT '0';";
	$add_col_query = strtr($add_col_query, array(':colname' => $entity));
	xtc_db_query($add_col_query);
	if($allow_all) {
		$allow_query = "UPDATE admin_access SET `:colname` = 1;";
		$allow_query = strtr($allow_query, array(':colname' => $entity));
		xtc_db_query($allow_query);
	}
	return true;
}

if(!empty($min_php))
{
	if(version_compare(PHP_VERSION, $min_php) < 0)
	{
		die("Es wird mindestens PHP-Version $min_php benötigt! – Bitte verwenden Sie nach Möglichkeit immer die empfohlene PHP-Version für Ihre Shopsystem-Installation!");
	}
}

if(!empty($sql)) {
	echo "Fuehre Datenbankanpassungen durch ...\n";
	foreach($sql as $query) {
		xtc_db_query($query);
	}
}

if(!empty($admin_access)) {
	echo "Erzeuge neue Admin-Rechte ...\n";
	foreach($admin_access as $entity) {
		addAdminAccess($entity);
  }
}

if(!empty($orders_status)) {
	echo "Lege Bestellstatus an ...\n";
	$next_id = findNextOrdersStatusId();
	foreach($orders_status as $os) {
		foreach($os as $lang_id => $osname) {
			addOrdersStatus($next_id, $osname, $lang_id);
		}
		$next_id++;
	}
}


if(!empty($dirs)) {
	echo "Erzeuge Verzeichnisse ...\n";
	foreach($dirs as $dirdata) {
		if(!is_dir($dirdata['dirname'])) {
			$dir_made = mkdir($dirdata['dirname'], $dirdata['mode'], $dirdata['recursive']);
			if($dir_made !== true) {
				echo "FEHLER: ". $dirdata['dirname'] ." konnte nicht erzeugt werden!\n";
			}
		}
	}
}

if(!empty($fileperms)) {
	echo "Ueberpruefe Datei-/Verzeichnisrechte ...\n";
	foreach($fileperms as $fp) {
		if($fp['access'] == 'write') {
			if(is_writeable($fp['file'])) {
				echo $fp['file'] . " - OK\n";
			}
			else {
				echo $fp['file'] ." - FEHLER: muss beschreibbar sein!\n";
			}
		}
	}
}

if(!empty($mail_templates))
{
	echo "<p>Installiere E-Mail-Vorlagen ...\n</p>";
	foreach($mail_templates as $template_name => $admin_titles)
	{
		$coo_amazonadvpay_mail_installer = new MailTemplateInstaller($template_name);
		foreach($admin_titles as $lang_code => $template_description)
		{
			$coo_amazonadvpay_mail_installer->set_admin_label($lang_code, $template_description);
		}
		$coo_amazonadvpay_mail_installer->install();
	}
}

if(columnExists('address_book', 'customer_b2b_status') == false)
{
	xtc_db_query("ALTER TABLE `address_book` ADD `customer_b2b_status` TINYINT(1) NOT NULL");
}

echo "<p>Leere Seitencache ...\n<p>";
$coo_cache_control =& MainFactory::create_object('CacheControl');
$coo_cache_control->clear_content_view_cache();
$coo_cache_control->clear_templates_c();
$coo_cache_control->remove_reset_token();
if(class_exists('PhraseCacheBuilder'))
{
	echo "<p>Leere Textcache ...\n<p>";
	$coo_phrase_cache_builder = MainFactory::create_object('PhraseCacheBuilder', array());
	$coo_phrase_cache_builder->build();
}
echo "<p>Leere Modulcache ...\n<p>";
$coo_cache_control->clear_data_cache();


echo "\n\n<strong>Fertig.</strong>\n";
$t_main_content = ob_get_clean();
$t_main_content = nl2br($t_main_content);
?>
<!DOCTYPE html>
<html>
	<head>
		<title>Modul-Installer</title>
		<style type="text/css">
			body { font: 0.8em sans-serif; }
		</style>
	</head>
	<body>
		<h1>Installer: <?php echo $t_module_name ?></h1>

		<div class="output">
			<?php echo $t_main_content; ?>
		</div>
	</body>
</html>
